
#property copyright "Copyright 2008. Victor Nicolaev"
#property link      "vinin@mail.ru"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Khaki
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_level1 0
#property indicator_level2 60
#property indicator_level3 -60
#property indicator_levelcolor Aqua

#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

#property indicator_maximum 100
#property indicator_minimum -100
//---- input parameters

extern int WPR_Period= 55;
extern int  MA_Period=5;
extern int  MA_Mode  =1;
extern int BB_Period=89;
extern double BB_Div=1.0;
extern double levelOb         = 60;
extern double levelOs         = -60;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = false;
extern string soundFile        = "alert2.wav";

double WPR[];
double WPRMidle[];
double WPRUP[];
double WPRDN[];
double MA[];
double trend[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorBuffers(6);
   SetIndexBuffer(0,MA);
   SetIndexBuffer(1,WPRMidle);
   SetIndexStyle(1,DRAW_LINE,1,1);
   SetIndexBuffer(2,WPRUP);
   SetIndexStyle(2,DRAW_LINE,4,1);
   SetIndexBuffer(3,WPRDN);
   SetIndexStyle(3,DRAW_LINE,4,1);
   SetIndexBuffer(4,WPR);
   SetIndexBuffer(5,trend);
   IndicatorShortName("MA_WPR("+WPR_Period+","+MA_Period+")");
   SetIndexLabel(0,"MA(WPR)");

   return(0); }

//+------------------------------------------------------------------+
int start() 
{
  int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
          
   //
   //
   //
   //
   //
   
   for (i=limit; i >= 0; i--) WPR[i] = (iWPR(Symbol(),Period(),WPR_Period,i)+50.0)*2.0;
   for (i=limit; i >= 0; i--) MA[i]  = iMAOnArray(WPR,0,MA_Period,0,MA_Mode,i);
   for (i=limit; i >= 0; i--) {
      double tmp=  (iBandsOnArray(WPR,0,BB_Period,1,0,MODE_UPPER,i)-
                    iBandsOnArray(WPR,0,BB_Period,1,0,MODE_LOWER,i))/2.0;
      WPRMidle[i]=iMAOnArray(WPR,0,BB_Period,0,MODE_SMA,i);
      WPRUP[i]=WPRMidle[i]+BB_Div*tmp;
      WPRDN[i]=WPRMidle[i]-BB_Div*tmp;
      trend[i] = 0;
      if (MA[i]>levelOb) trend[i] = 1;
      if (MA[i]<levelOs) trend[i] =-1;  
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"crossing overbought");
         if (trend[whichBar] == -1) doAlert(whichBar,"crossing oversold");
      }         
   }
   return(0); 
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol(),Period(),TimeToStr(TimeLocal(),TIME_SECONDS)," VininI BB ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," VininI BB MA WPR "),message);
             if (alertsSound)   PlaySound(soundFile);
   }
}


